<template>
  <div v-click-outside onselectstart="return false" style="-moz-user-select : none;">
    <input type="text" :value="value" :rowData="rowData" class="input__inner">
    <div v-if="isVisible" :class="[{pannel:true},{top_yes:topStyle}]">
      <div class="pannel-nav">
        <span class="fl" @click="prevYear"><i class="el-icon-d-arrow-left" /></span>
        <span class="fl" @click="prevMonth"><i class="el-icon-arrow-left" /></span>
        <span class="yearStyle">{{ time.year }}年</span>
        <span class="yearStyle">{{ time.month + 1 }}月</span>
        <span class="fr" @click="nextYear"><i class="el-icon-d-arrow-right" /></span>
        <span class="fr" @click="nextMonth"><i class="el-icon-arrow-right" /></span>
      </div>
      <div class="pannel-content">
        <div class="days">
          <span
            v-for="k in 7"
            :key="k"
            class="cell"
            style="border-bottom: solid 1px #E7E7EA;padding-bottom: 10px;margin-bottom: 10px;"
          >
            {{ weekDays[k - 1] }}
          </span>
          <div v-for="i in 6" :key="i">
            <div
              v-for="j in 7"
              :key="j"
              :class="[
                {notCurrentMonth:!isCurrentMonth(visibleDays[(i-1)*7+(j-1)]
                ),cellDays:true,cell:true,mb3:true},
                {today:isToday(visibleDays[(i-1)*7+(j-1)])},
                {pastDue:isPastDue(visibleDays[(i-1)*7+(j-1)])}
              ]"
              @click="chooseDate(visibleDays[(i-1)*7+(j-1)])"
              @dblclick="dblChooseDate(visibleDays[(i-1)*7+(j-1)])"
            >

              <el-popover
                placement="top"
                title=""
                width="50"
                trigger="hover"

                :disabled="!isDblDate(visibleDays[(i-1)*7+(j-1)])"
              >

                <div class="pop_style">{{ callbackTxt(visibleDays[(i - 1) * 7 + (j - 1)]) }}</div>
                <!--                <div class="pop_style">123</div>-->
                <span
                  slot="reference"
                  :class="[{select:isSelect(visibleDays[(i-1)*7+(j-1)])},
                           {dblDateStyle:isDblDate(visibleDays[(i-1)*7+(j-1)])}]"
                  :style="{background: isSelect(visibleDays[(i-1)*7+(j-1)])?$store.state.settings.theme:''}"
                >{{ visibleDays[(i - 1) * 7 + (j - 1)].getDate() }}</span>
              </el-popover>

            </div>
          </div>

        </div>
      </div>
      <div class="pannel-footer">
        <el-button v-if="!isDbl" size="mini" class="fr mt4" @click="CapacityPlanningGivePlanSubmit">确 定</el-button>
      </div>
      <div v-if="isVisible && isDbl" class="pannelTo">
        <div class="pannelTo_title mt5"><span class="bigText mr5">{{ dblTime.day }}日</span> <span class="samllText mr5">{{
          dblTime.year
        }}年{{ dblTime.month + 1 }}月</span><span class="samllText">星期{{ getweekday(handleDatetime(dblDate)) }}</span>
        </div>
        <div class="pannelTo_nav">

          <el-select v-model="schemeDate" size="small" style="width:240px;" @change="changeScheme">
            <el-option v-for="item in projectList" :key="item.CapCode" :value="item.CapCode" :label="item.CapName" />
          </el-select>
        </div>
        <div class="pannelTo_conent">
          <ul>
            <li style="margin-bottom: 12px;">
              <span class="fl fl_ml li_text">开始时间</span>
              <span class="fr fr_mr li_text">结束时间</span>
            </li>

            <li v-for="item in timeList" :key="item">
              <!-- <span  class='fl'>{{item.start}}</span> -->
              <el-time-select
                v-model="item.start"
                :disabled="true"
                :picker-options="{
                  start: '00:00',
                  step: '00:01',
                  end: '23:59'
                }"
                placeholder="开始"
                size="small"
                style="width:100px;"
                class="fl"
              />
              <span class="li_text_color">~</span>
              <el-time-select
                v-model="item.end"
                :disabled="true"
                :picker-options="{
                  start: '00:00',
                  step: '00:01',
                  end: '23:59'
                }"
                placeholder="结束"
                size="small"
                style="width:100px;"
                class="fr"
              />
              <!-- <span  class='fr'>{{item.end}}</span> -->
            </li>

          </ul>
        </div>
        <div class="pannelTo_footer">
          <el-button size="mini" class="fr bt_style" @click="CapacityPlanningGivePlanSubmit">确 定</el-button>
          <el-button size="mini" class="fr" @click="close">取 消</el-button>
        </div>
      </div>
    </div>

  </div>
</template>
<script>
import * as funsdates from '@/utils/funsdate'
import {
  CapacityPlanningCalendar,
  CapacityPlanningGivePlanSubmit,
  CapacityPlanningOnclickSelect,
  CapacityPlanningSetupSearch
} from '@/api/produceManager'
import { handleDatetime } from '@/utils/global'

var time = null
export default {
  directives: {
    clickOutside: {
      bind(el, bindings, vnode) {
        const handler = (e) => {
          if (el.contains(e.target)) {
            if (!vnode.context.isVisible) {
              vnode.context.focus()
            }
          } else {
            if (vnode.context.isVisible) {
              vnode.context.blur()
            }
          }
        }
        el.handler = handler
        document.addEventListener('click', handler)
      },
      unbind(el) {
        document.removeEventListener('click', el.handler)
      }
    }
  },
  props: {
    value: {
      type: Array,
      default: null
    },
    defArr: {
      type: Array,
      default: Array
    },
    rowData: {
      type: Object,
      default: null
    },
    CapacityPlanningSearch: {
      type: Function,
      default: null
    }

  },

  data() {
    const { year, month } = funsdates.getYearMonthDay(new Date())
    return {
      dblTime: {
        year: '',
        month: '',
        day: ''
      },
      schemeDate: '',
      dblDate: '',
      projectList: [],
      timeList: [],
      timeArr: [],
      isDbl: false,
      dateNow: new Date(),
      isVisible: false,
      time: { year, month },
      weekDays: ['日', '一', '二', '三', '四', '五', '六'],
      changeTime: '',
      changeTimeArr: [],
      // defArr: [],
      dm_top: '',
      topStyle: false,
      form: {
        rows: 1000,
        page: 1
      },
      projectDef: []

    }
  },
  computed: {
    visibleDays() {
      const { year, month } = funsdates.getYearMonthDay(new Date(this.time.year, this.time.month, 1))
      const currentFirstDay = funsdates.getDay(year, month, 1)// 第一天
      const week = currentFirstDay.getDay()
      const satrtDay = currentFirstDay - week * 60 * 60 * 1000 * 24
      const arr = []
      for (let i = 0; i < 42; i++) {
        arr.push(new Date(satrtDay + i * 60 * 60 * 1000 * 24))
      }
      return arr
    },

    formatDate() {
      const { year, month, day } = funsdates.getYearMonthDay(this.dateNow)
      return `${year}-${month + 1}-${day}`
    }
  },
  mounted() {
  },
  methods: {
    getDblTime() {
      const { year, month, day } = funsdates.getYearMonthDay(this.dblDate)
      this.dblTime = { year, month, day }
    },
    getweekday(date) {
      var weekArray = new Array('日', '一', '二', '三', '四', '五', '六')
      var week = weekArray[new Date(date).getDay()]// 注意此处必须是先new一个Date
      return week
    },
    callbackTxt(date) {
      let code = ''
      let name = ''
      if (this.isDblDate(date)) {
        for (const i in this.defArr) {
          if (this.defArr[i].name === this.handleDatetime(date)) {
            code = this.defArr[i].key
          }
        }
      }
      for (const i in this.projectDef) {
        if (this.projectDef[i].code === code) {
          name = this.projectDef[i].name
        }
      }
      return name
    },
    getHeight() {
      let winHeight // 屏幕总高度
      if (window.innerHeight) {
        winHeight = window.innerHeight
      } else if ((document.body) && (document.body.clientHeight)) {
        winHeight = document.body.clientHeight
      }

      const e = event || window.event

      const nowHeigth = e.clientY
      if (nowHeigth >= 500) {
        this.topStyle = true
      }
    },
    // 改变时间格式
    formatScheme(val) {
      const arr = []
      for (const i in val) {
        const object = {
          start: '',
          end: ''
        }
        const s = val[i].split('~')
        object.start = s[0]
        object.end = s[1]
        arr.push(object)
      }
      return arr
    },
    // 改变方案
    changeScheme() {
      let toList = []
      for (const i in this.projectList) {
        if (this.schemeDate === this.projectList[i].CapCode) {
          toList = this.projectList[i].list
        }
      }

      for (const i in this.defArr) {
        if (this.defArr[i].name === this.changeTime) {
          this.defArr[i].key = this.schemeDate
        }
      }

      this.timeList = this.formatScheme(toList)
    },
    focus() {
      this.isVisible = true

      this.getCapacityPlanningCalendar()
      this.getHeight()
      this.getCapacityPlanningSetupSearch()
      this.CapacityPlanningSearch()
    },
    blur() {
      this.isDbl = false // 右侧面板关闭
      this.isVisible = false// 主面板关闭
      this.$emit('over', true)// 给父组件发出请求，告诉他已经完成操作，可调用获取列表接口
    },
    isCurrentMonth(date) {
      const { year, month } = funsdates.getYearMonthDay(new Date(this.time.year,
        this.time.month, 1))
      const { year: y, month: m } = funsdates.getYearMonthDay(date)
      return year === y && month === m
    },
    isToday(date) {
      const { year, month, day } = funsdates.getYearMonthDay(this.dateNow)
      const { year: y, month: m, day: d } = funsdates.getYearMonthDay(date)
      return year === y && month === m && day === d
    },
    // 过期时间
    isPastDue(date) {
      const newDate = this.handleDatetime(new Date())
      return new Date(newDate) > date && this.handleDatetime(date) !== newDate
    },
    chooseDate(date) {
      clearTimeout(time) // 首先清除计时器
      time = setTimeout(() => {
        this.time = funsdates.getYearMonthDay(date)
        if (typeof this.value === 'string') {
          this.value = this.value.split(',')
        }
        this.isDbl = false
        // 可以点击的日期
        if (!this.isPastDue(date)) {
          if ((this.value.indexOf(this.handleDatetime(date)) < 0 && this.value !== '') || this.value === '') { // 数组添加
            this.value.push(this.handleDatetime(date)) // 新增到input里
            const data = {
              name: this.handleDatetime(date),
              key: this.rowData.CaptPlanWorkShiftCode
            }
            this.defArr.push(data) // 新增到 默认数组里
          } else if (this.value.indexOf(this.handleDatetime(date)) >= 0) { // 数组减去
            const indexV = this.value.indexOf(this.handleDatetime(date))
            this.value.splice(indexV, 1)
            for (const i in this.defArr) {
              if (this.defArr[i].name === this.handleDatetime(date)) {
                this.defArr.splice(i, 1)
              }
            }
          }
        }
        this.$emit('input', this.value)
      }, 300)
    },
    dblChooseDate(date) {
      if (!this.isPastDue(date)) {
        clearTimeout(time)
        time = setTimeout(() => {
          this.time = funsdates.getYearMonthDay(date)
          if (typeof this.value === 'string') {
            this.value = this.value.split(',')
          }
          // 可以点击的日期
          if (!this.isPastDue(date)) {
            if ((this.value.indexOf(this.handleDatetime(date)) < 0 && this.value !== '') || this.value === '') { // 数组添加
              this.value.push(this.handleDatetime(date)) // 新增到input里
              const data = {
                name: this.handleDatetime(date),
                key: this.rowData.CaptPlanWorkShiftCode
              }
              this.defArr.push(data) // 新增到 默认数组里
              this.dblDate = date
              this.isDbl = true // 右侧展开

              this.changeTime = this.handleDatetime(date)

              const DATA = {
                CaptPlanWorkShiftCode: this.defArr.find(item => item.name === this.changeTime).key,
                captplanid: this.rowData.CaptPlanId,
                datetime: this.handleDatetime(date)
              }
              this.getCapacityPlanningOnclickSelect(DATA)
              this.getDblTime()
            } else if (this.value.indexOf(this.handleDatetime(date)) >= 0) {
              this.dblDate = date
              this.isDbl = true // 右侧展开

              this.changeTime = this.handleDatetime(date)

              const DATA = {
                CaptPlanWorkShiftCode: this.defArr.find(item => item.name === this.changeTime).key,
                captplanid: this.rowData.CaptPlanId,
                datetime: this.handleDatetime(date)
              }
              this.getCapacityPlanningOnclickSelect(DATA)
              this.getDblTime()

              //   const indexV = this.value.indexOf(this.handleDatetime(date))
              //   this.value.splice(indexV, 1)
              //   for (const i in this.defArr) {
              //     if (this.defArr[i].name === this.handleDatetime(date)) {
              //       this.defArr.splice(i, 1)
              //     }
              //   }
            }
          }
          this.$emit('input', this.value)
        }, 300)
      }
    },
    isDblDate(date) {
      for (const i in this.defArr) {
        if (this.defArr[i].key !== '') {
          if (this.defArr[i].name === this.handleDatetime(date) && this.defArr[i].key !== this.rowData.CaptPlanWorkShiftCode) {
            return true
          }
        }
      }
      // if(this.dblDate){
      //     let {year,month,day} = funsdates.getYearMonthDay(this.dblDate)
      //     let {year:y,month:m,day:d} = funsdates.getYearMonthDay(date)
      //     return year === y && month === m && day === d;
      // }
    },
    isSelect(date) {
      if (this.value.indexOf(this.handleDatetime(date)) >= 0) {
        return true
      }
    },
    prevMonth() {
      const d = funsdates.getDay(this.time.year, this.time.month, 1)
      d.setMonth(d.getMonth() - 1)
      this.time = funsdates.getYearMonthDay(d)
    },
    nextMonth() {
      const d = funsdates.getDay(this.time.year, this.time.month, 1)
      d.setMonth(d.getMonth() + 1)
      this.time = funsdates.getYearMonthDay(d)
    },
    prevYear() {
      const d = funsdates.getDay(this.time.year, this.time.month, 1)
      d.setYear(d.getFullYear() - 1)
      this.time = funsdates.getYearMonthDay(d)
    },
    nextYear() {
      const d = funsdates.getDay(this.time.year, this.time.month, 1)
      d.setYear(d.getFullYear() + 1)
      this.time = funsdates.getYearMonthDay(d)
    },
    handleDatetime(date) {
      const { year, month, day } = funsdates.getYearMonthDay(date)
      const res = `${year}-${this.add_zero(month + 1)}-${this.add_zero(day)}`
      return res
    },
    add_zero(date) {
      if (date < 10) {
        return '0' + date
      } else {
        return date
      }
    },
    // 选中的方案
    // selectDate(){
    //     for(let i in this.defArr){
    //             if(this.projectList[i].CapStus != 'N'){
    //                 this.schemeDate = this.projectList[i].CapStus
    //             }else{
    //                 this.schemeDate = this.rowData.CaptPlanWorkShiftCode
    //         }
    //         }
    // },
    // 双击请求数据
    getCapacityPlanningOnclickSelect(data) {
      CapacityPlanningOnclickSelect(data).then((res) => {
        this.projectList = res.data

        // for (const i in this.defArr) {
        //   console.log(this.defArr[i].name === data.DateTime, 6)
        //   if (this.defArr[i].name === data.DateTime) {
        //     this.schemeDate = this.defArr[i].key
        //   }
        // }

        this.schemeDate = data.CaptPlanWorkShiftCode

        this.changeScheme()
      })
    },
    // 工作日历提交
    CapacityPlanningGivePlanSubmit() {
      const formData = new FormData()
      formData.append('wkshopcode', this.rowData.CaptPlanWorkShopid)// 车间编码
      formData.append('capunitcode', this.rowData.CaptPlanDeviceTypeid)// 生产单元编码（产线编码）
      formData.append('captplanid', this.rowData.CaptPlanId)// 产能资源id
      formData.append('capsetupcode', this.rowData.CaptPlanWorkShiftCode) // 默认方案编码
      formData.append('captplantype', this.rowData.CaptPlanType)// 资源类型
      formData.append('worklist', JSON.stringify(this.defArr))// 工作日历数据集
      // for (const [a, b] of formData.entries()) {
      //   console.log(a, ':', b)
      // }
      CapacityPlanningGivePlanSubmit(formData).then(res => {
        if (res.code === '200') {
          this.$message.success('保存成功！')
          this.blur()
          this.CapacityPlanningSearch()
        }
      })
    },
    getCapacityPlanningCalendar() {
      CapacityPlanningCalendar({ captplanid: this.rowData.CaptPlanId }).then((res) => {
        const currentDate = handleDatetime(new Date())
        this.defArr = res.data.filter(i => i.name >= currentDate)
      })
    },
    closeCapacityPlanningCalendar() {
      CapacityPlanningCalendar({ captplanid: this.rowData.CaptPlanId }).then((res) => {
        const nameList = []
        for (const i in res.data) {
          nameList.push(res.data[i].name)
          if (res.data[i].key === '') {
            res.data[i].key = this.rowData.CaptPlanWorkShiftCode
          }
        }
        for (const i in this.defArr) {
          for (const j in res.data) {
            if (this.defArr[i].name === this.changeTime && res.data[j].name === this.changeTime) {
              this.defArr[i].key = res.data[j].key
            } else if (this.defArr[i].name === this.changeTime && nameList.indexOf(this.changeTime) === -1) {
              this.defArr[i].key = this.rowData.CaptPlanWorkShiftCode
            }
          }
        }
      })
    },
    close() {
      setTimeout(() => {
        this.isDbl = false
        this.closeCapacityPlanningCalendar()
      }, 300)
    },
    getCapacityPlanningSetupSearch() {
      CapacityPlanningSetupSearch(this.form).then((res) => {
        this.projectDef = res.data
      })
    }

  }
}
</script>
<style lang="scss" scoped>
$main_color: #42b983;
.pannelTo {
  position: absolute;
  z-index: 1000;
  left: 44.8*7px;
  top: -5px;
  width: 45*7px;
  box-shadow: 0 2px 12px 0 rgba(0, 0, 0, 0.1);
  background: #FFFFFF;
  margin: 5px 0;
  border: 1px solid #E4E7ED;
  -webkit-box-shadow: 0 2px 12px 0 rgba(0, 0, 0, 0.1);
  box-shadow: 0 2px 12px 0 rgba(0, 0, 0, 0.1);
  background: #FFFFFF;
  border-radius: 4px;
}

.pannelTo_conent {
  padding: 0 37px 0 37px;
  height: 276px;;
}

.pannelTo_footer {
  overflow: hidden;
}

.pannelTo_conent ul li {
  overflow: hidden;
  text-align: center;
  margin-bottom: 16px;
}

.fr {
  float: right;
}

.fr_mr {
  margin-right: 20px;
}

.fl_ml {
  margin-left: 20px;
}

.fl {
  float: left;
}

.bt_style {
  margin-bottom: 10px;
  margin-left: 10px;
  margin-right: 15px;
}

.pannel {
  width: 45*7px;
  z-index: 1000;
  position: absolute;
  box-shadow: 0 2px 12px 0 rgba(0, 0, 0, 0.1);
  background: #FFFFFF;
  color: #606266;
  border: 1px solid #E4E7ED;
  -webkit-box-shadow: 0 2px 12px 0 rgba(0, 0, 0, 0.1);
  box-shadow: 0 2px 12px 0 rgba(0, 0, 0, 0.1);
  background: #FFFFFF;
  border-radius: 4px;
  line-height: 30px;
  margin: 5px 0;
  //overflow: visible !important;
  //box-sizing: border-box;

  .pannel-nav {
    position: relative;
    text-align: center;
    // height: 28px;
    overflow: hidden;
    margin: 0 13px 0 13px;
    padding: 25px 0px 10px 0px;

    span {
      cursor: pointer;
      user-select: none;
      padding: 5px;
      color: #606266;
      font-weight: 500;
      vertical-align: top;
      height: 26px;

      i {
        vertical-align: top;
        font-size: 12px;
        color: #303133;
      }
    }
  }

  .pannel-content {
    .days {
      margin-left: 6px;
    }

    .cell {
      display: inline-flex;
      justify-content: center;
      align-items: center;
      width: 42.3px;
      height: 30px;
      padding: 4px 0;
      -webkit-box-sizing: border-box;
      box-sizing: border-box;
      text-align: center;
      cursor: pointer;
      position: relative;

      span {
        width: 24px;
        height: 24px;
        display: block;
        margin: 0 auto;
        line-height: 24px;
        position: absolute;
        left: 50%;
        -webkit-transform: translateX(-50%);
        transform: translateX(-50%);
        border-radius: 50%;
        -webkit-tap-highlight-color: transparent;
        outline: none;
      }

    }

    .cellDays:hover {
      color: $main_color;
    }
  }

  .pannel-footer {
    // height: 32px;
    border-top: 1px solid #E7E7EA;
    padding: 10px;
    overflow: hidden;
    height: 58px;

  }
}

.notCurrentMonth {
  color: #C0C4CC
}

.today {
  color: $main_color;
  font-weight: bold;
}

.select {
  background-color: $main_color;
  border-radius: 50%;
  color: #FFFFFF !important;
}

.dblDateStyle {
  background-color: #FFCA00 !important;
  border-radius: 50%;
  color: #FFFFFF !important;
}

.pannelTo_nav {
  padding: 10px 20px 18px 20px;
  text-align: center
}

.pannelTo_conent ul {
  margin: 0;
  padding: 0;
  list-style: none;
}

.yearStyle {

  font-weight: 500;
  padding: 0 5px;
  font-size: 14px;
  line-height: 22px;
  text-align: center;
  cursor: pointer;
  color: #444444;
}

.input__inner {

  -webkit-appearance: none;
  background-color: #FFFFFF;
  background-image: none;
  border-radius: 4px;
  border: 1px solid #DCDFE6;
  -webkit-box-sizing: border-box;
  box-sizing: border-box;
  color: #606266;
  display: inline-block;
  font-size: inherit;
  height: 40px;
  line-height: 40px;
  outline: none;
  padding: 0 15px;
  -webkit-transition: border-color 0.2s cubic-bezier(0.645, 0.045, 0.355, 1);
  transition: border-color 0.2s cubic-bezier(0.645, 0.045, 0.355, 1);
  width: 100%;
}

.li_text {
  font-size: 12px;
  font-weight: 400;
  line-height: 17px
}

.li_text_color {
  color: #C7C7CB;
  margin-top: 3px;
}

.pastDue {
  background-color: #F5F7FA;
  opacity: 1;
  cursor: not-allowed !important;
  color: #C0C4CC !important;
}

.top_yes {
  top: -420px;
}

.pop_style {
  font-size: 14px;
  text-align: center;
}

.bigText {
  font-size: 18px;
  color: #606266;
  font-weight: 500;
}

.samllText {
  color: #C0C4CC;
  font-size: 13px;
  vertical-align: bottom;
}

.pannelTo_title {
  padding-left: 37px;
}

.mr5 {
  margin-right: 5px;
}

.mt5 {
  margin-top: 18px;
}

.mb3 {
  margin-bottom: 3px;
}

.mt4 {
  margin-top: 4px;
}
</style>
